#include <bits/stdc++.h>

using namespace std;

long long a[75000],b[75000],c[74999];

int nzd(long long a[],long long n){
	long long r=a[0];
	for(long long int i=1;i<n;i++){
		r=__gcd(r,a[i]);
		if(r==1){
			return 1;
		}
	}
	return r;
}

int main(){
	ios::sync_with_stdio(false); cin.tie(0);
	int t,n,m,i,j,p,x,r[]={1,1,1,1,1}; cin>>t;
	
	for(i=0;i<t;i++){
		cin>>n>>m;
		cin>>a[0];
		for(j=1;j<n;j++){
			cin>>a[j];
			c[j-1]=a[j]-a[j-1];
		}
		x=nzd(c,n-1);
		if(x==1){
			r[i]=0;
		}
		for(j=0;j<m;j++){
			cin>>b[j];
			if((a[0]-b[j])%x==0){
				r[i]=0;
			}
		}
	}
	
	for(i=0;i<t;i++){
		cout<<r[i]<<"\n";
	}
	
	return 0;
}